from __future__ import division
from picamera.array import PiRGBArray
from picamera import PiCamera
from imutils.video.pivideostream import PiVideoStream
from imutils.video import FPS
from time import sleep, time,strftime,gmtime
from sys import argv
import cv2
import sys
import imutils
import argparse
import os
import numpy as np
import datetime as dt
import multiprocessing as mp
from math import ceil,sqrt,degrees
import getopt
import threading
import RPi.GPIO as GPIO
import subprocess

sys.path.append('.')
import RTIMU



SETTINGS_FILE               = "RTIMULib"
EXIT                        = 0
EXECUTION_TIME              = 300
ERR_BLINK_TIME              = 5
WARNING_BLINK_TIME          =  .1
VIDEO_EXEC_TIME             = 60
SAVE_DIRECTORY              = '/media/pi/U/'#'Test/Ope_'
TESTING                     = 0
ERR_IMU                     = 0
ERR_WARNING                     = 0
ERR_DANGER                     = 0
ACCIDENT_THRESHOLD          = 1
CANNY_LINE_LOW_THRESHOLD    = 30  #canny(img, low_threshold, high_threshold):
CANNY_LINE_HIGH_THRESHOLD   = 80
GAUSSIAN_KERNEL_SIZE        = 9  #cv2.GaussianBlur(img, (kernel_size, kernel_size), 0)
GAUSSIAN_BORDER_TYPE        = 0  #cv2.GaussianBlur(img, (kernel_size, kernel_size), 0)
HOUGH_LINES_RHO             = 	.8			#hough_lines(img, rho, theta, threshold, min_line_len, max_line_gap):
HOUGH_LINES_THETA           = np.pi/180				#hough_lines(img, rho, theta, threshold, min_line_len, max_line_gap):
HOUGH_LINES_THRESHOLD       = 	15				#hough_lines(img, rho, theta, threshold, min_line_len, max_line_gap):
HOUGH_LINES_MIN_LINE_LENGTH = 	5						#hough_lines(img, rho, theta, threshold, min_line_len, max_line_gap):
HOUGH_LINES_MAX_LINE_GAP    = 	3					#hough_lines(img, rho, theta, threshold, min_line_len, max_line_gap):
IMU_LED                     = 25
WARNING_LED                 = 12
DANGER_LED                  = 21


GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(IMU_LED, GPIO.OUT)
GPIO.setup(WARNING_LED, GPIO.OUT)
GPIO.setup(DANGER_LED, GPIO.OUT)
blue = GPIO.PWM(IMU_LED,5)
#yellow = GPIO.PWM(WARNING_LED,100)
#red = GPIO.PWM(DANGER_LED,100)



if len(argv) >1:
	if argv[1] == ("test" or "t" or "-t" or 1 or "1"):
		TESTING =1

direction = ""
x = 0.0
y = 0.0
z = 0.0


print("Using settings file " + SETTINGS_FILE + ".ini")
if not os.path.exists(SETTINGS_FILE + ".ini"):
  print("Settings file does not exist, will be created")

s = RTIMU.Settings(SETTINGS_FILE)
imu = RTIMU.RTIMU(s)

print("IMU Name: " + imu.IMUName())

if (not imu.IMUInit()):
	print("IMU Init Failed")
	sys.exit(1)
else:
	print("IMU Init Succeeded")

# this is a good time to set any fusion parameters

imu.setSlerpPower(0.02)
imu.setGyroEnable(True)
imu.setAccelEnable(True)
imu.setCompassEnable(True)

poll_interval = imu.IMUGetPollInterval()
print("Recommended Poll Interval: %dmS\n" % poll_interval)
# poll_interval = 100

INTERVAL = 5
interval = INTERVAL

def get_direction (x,y,z):
  if ( x >= 28 ):
	  direction = "N"
  elif ( x >= 15 and x <= 28 ):
	if ( y >= 0 ):
	  direction = "NW"
	else:
	  direction = "NE"
  elif ( x >= -18 and x <= 15 ):
	if ( y >= 0 ):
	  direction = "W"
	else:
	  direction = "E"
  elif ( x >= -35 and x <= -18 ):
	if ( y >= 0 ):
	  direction = "SW"
	else:
	  direction = "SE"
  elif ( x <= -35 ):
	  direction = "S"
  return direction



os.chdir(SAVE_DIRECTORY)

resolution = (480, 360)

# initialize the camera and grab a reference to the raw camera capture
camera = PiCamera()
camera.resolution = resolution
camera.framerate = 30
rawCapture = PiRGBArray(camera, size=resolution)

def getFaces( img ):

	gray = cv2.cvtColor(img, cv2.COLOR_BGR2GRAY)
	faces = faceCascade.detectMultiScale(
		gray,
		scaleFactor=1.1,
		minNeighbors=5,
		minSize=(30, 30),
		flags = cv2.cv.CV_HAAR_SCALE_IMAGE
		)
	for (x, y, w, h) in faces:
		cv2.circle(img, (x+w/2, y+h/2), int((w+h)/3), (255, 255, 255), 1)
	return img


def capture_frame():
	filename = dt.datetime.now().strftime('%Y-%m-%d_%H:%M:%S:%f') +'.jpg'
	print filename
	camera.annotate_text = filename
	print"PRBLEM"
	camera.capture(filename,use_video_port=True)
	return "DONE"

def show_img(img):
	cv2.imshow("Frame", img)
	cv2.waitKey(0)
	cv2.destroyAllWindows()
 
	# clear the stream in preparation for the next frame
	rawCapture.truncate(0)
 
	# if the `q` key was pressed, break from the loop

def detect_line(img):

	global errLaneRecordingTime
	#Crop image
	height, width, channels = img.shape
	new_height = height * (.8)
	new_width = width * (6/6)
	img_crop = img[new_height:height,int((width - new_width)/2):int(new_width + (width - new_width)/2)]

	#Convert to Grayscale
	gray = cv2.cvtColor(img_crop, cv2.COLOR_BGR2GRAY)

	#Blur image to reduce noise
	blurred = cv2.GaussianBlur(gray, (GAUSSIAN_KERNEL_SIZE, GAUSSIAN_KERNEL_SIZE), GAUSSIAN_BORDER_TYPE)

	#Perform canny edge-detection
	edged = cv2.Canny(blurred, CANNY_LINE_LOW_THRESHOLD, CANNY_LINE_HIGH_THRESHOLD)

	#Perform hough lines probalistic transform
	lines = cv2.HoughLinesP(edged,HOUGH_LINES_RHO,HOUGH_LINES_THETA,HOUGH_LINES_THRESHOLD,HOUGH_LINES_MIN_LINE_LENGTH,HOUGH_LINES_MAX_LINE_GAP)

	#Draw lines on input image
	if(lines != None):
		# Get longest lines for the left and right lanes
		[rx_max1, ry_max1, rx_max2, ry_max2] = [0,0,0,0]
		[lx_max1, ly_max1, lx_max2, ly_max2] = [0,0,0,0]
		largest_right_dist = 0
		largest_left_dist = 0
		for x1,y1,x2,y2 in lines[0]:
			dist = np.hypot(x1 - x2, y1 - y2)
			slope = (y2 - y1) / (x2 - x1)
			if (slope > .5):
				if (dist > largest_right_dist):
					largest_right_dist = dist
					[rx_max1, ry_max1, rx_max2, ry_max2] = [x1,y1,x2,y2]
			elif (slope < -.5):
				if dist > largest_left_dist:
					largest_left_dist = dist
					[lx_max1, ly_max1, lx_max2, ly_max2] = [x1,y1,x2,y2]

		if [rx_max1, ry_max1, rx_max2, ry_max2] == [0,0,0,0] or [lx_max1, ly_max1, lx_max2, ly_max2] == [0,0,0,0]:
			valid_lines = False
		else:
			valid_lines = True

		#cv2.line(img_crop,(lx_max1,ly_max1),(lx_max2,ly_max2),(0,255,0),2)
		#cv2.line(img_crop,(rx_max1,ry_max1),(rx_max2,ry_max2),(0,255,0),2)

		#Extrapolate the left and right lane markings
		imgH, imgW = (img_crop.shape[0], img_crop.shape[1])

		rx1, ry1 = line_intersection( ((rx_max1,ry_max1),(rx_max2,ry_max2)), ((0,0),(imgW,0)) )
		rx2, ry2 = line_intersection( ((rx_max1,ry_max1),(rx_max2,ry_max2)), ((0,imgH),(imgW,imgH)) )

		lx1, ly1 = line_intersection( ((lx_max1,ly_max1),(lx_max2,ly_max2)), ((0,0),(imgW,0)) )
		lx2, ly2 = line_intersection( ((lx_max1,ly_max1),(lx_max2,ly_max2)), ((0,imgH),(imgW,imgH)) )

		#cv2.line(img_crop,(int(rx1),int(ry1)),(int(rx2),int(ry2)),(0,255,0),2)
		#cv2.line(img_crop,(int(lx1),int(ly1)),(int(lx2),int(ly2)),(0,255,0),2)
	
		right_mpnt = ( (rx1 + rx2) / 2, (ry1 + ry2) / 2 )
		left_mpnt  = ( (lx1 + lx2) / 2, (ly1 + ly2) / 2 )
		top_mpnt   = ( (lx1 + rx1) / 2, (ly1 + ry1) / 2 )
		bot_mpnt   = ( (lx2 + rx2) / 2, (ly2 + ry2) / 2 )

		right_depart = False
		danger_right_depart = False
		left_depart = False
		danger_left_depart = False

		'''
		#Detect if left or right line lie outside threshold
		percentage1 = 0.30
		right_thresh1 = imgW - (imgW * ((1 - percentage1) / 2))
		left_thresh1  = imgW * ((1 - percentage1) / 2)

		if (left_mpnt[0] < left_thresh1):
			right_depart = True
		else:
			right_depart = False

		if (right_mpnt[0] > right_thresh1):
			left_depart = True
		else:
			left_depart = False
		'''

		#OR

		#Detect if bottom midpoint lies outside threshold
		percentage2a = 0.10
		right_thresh2a = imgW - (imgW * ((1 - percentage2a) / 2))
		left_thresh2a  = imgW * ((1 - percentage2a) / 2)

		percentage2b = 0.20
		right_thresh2b = imgW - (imgW * ((1 - percentage2b) / 2))
		left_thresh2b  = imgW * ((1 - percentage2b) / 2)

		if (bot_mpnt[0] < left_thresh2a and bot_mpnt[0] < left_thresh2b and valid_lines):
			right_depart = True
			danger_right_depart = True
		elif (bot_mpnt[0] < left_thresh2a and bot_mpnt[0] > left_thresh2b and valid_lines):
			right_depart = True

		if (bot_mpnt[0] > right_thresh2a and bot_mpnt[0] > right_thresh2b and valid_lines):
			left_depart = True
			danger_right_depart = True
		elif (bot_mpnt[0] > right_thresh2a and bot_mpnt[0] < right_thresh2b and valid_lines):
			left_depart = True

		#OR

		'''
		#Check angle of top and bottom midpoint line
		right_angle     = 3
		danger_right_angle = 1
		left_angle     = -3
		danger_left_angle = -1
		if (bot_mpnt[0] - top_mpnt[0]) == 0:
			right_depart = False
			danger_right_depart = False
			left_depart = False
			danger_left_depart = False
		else:
			slope = float(bot_mpnt[1] - top_mpnt[1]) / float(bot_mpnt[0] - top_mpnt[0])
			if (slope < right_angle and slope < danger_right_angle and slope > 0 and valid_lines):
				right_depart = True
				danger_right_depart = True
			elif (slope < right_angle and slope > danger_right_angle and slope > 0 and valid_lines):
				right_depart = True
			#else:
			#	right_depart = False
			#	danger_right_depart = False

			if (slope > left_angle and slope > danger_left_angle and slope < 0 and valid_lines):
				left_depart = True
				danger_left_depart = True
			elif (slope > left_angle and slope < danger_left_angle and slope < 0 and valid_lines):
				left_depart = True
			#else:
			#	left_depart = False
			#	danger_left_depart = False
		'''

		print slope
		print "Right Depart:        ", right_depart
		print "Danger Right Depart: ", danger_right_depart
		print "Left Depart:         ", left_depart
		print "Danger Left Depart:  ", danger_left_depart

		if (left_depart or right_depart):
			errLaneRecordingTime = time()
			#yellow.start(100)
			GPIO.output(WARNING_LED,GPIO.HIGH)
			ERR_WARNING = 1
		else:
			GPIO.output(WARNING_LED,GPIO.LOW)

		if (danger_left_depart or danger_right_depart):
			errLaneRecordingTime = time()
			#red.start(100)
			GPIO.output(DANGER_LED,GPIO.HIGH)
			ERR_DANGER = 1
		else:
			GPIO.output(DANGER_LED,GPIO.LOW)

		return img_crop,((int(lx1),int(ly1)),(int(lx2),int(ly2)),(int(rx1),int(ry1)),(int(rx2),int(ry2)))
	else:
		return img_crop, ((0,0),(0,0),(0,0),(0,0))
	
	
	
	#cv2.imshow("line detect test", img) 
	#cv2.waitKey(0)

#Inspired by: http://stackoverflow.com/questions/20677795/how-do-i-compute-the-intersection-point-of-two-lines-in-python
def line_intersection(line1, line2):
	xdiff = (line1[0][0] - line1[1][0], line2[0][0] - line2[1][0])
	ydiff = (line1[0][1] - line1[1][1], line2[0][1] - line2[1][1])
	
	def det(a, b):
	    return a[0] * b[1] - a[1] * b[0]
	
	div = det(xdiff, ydiff)
	if div == 0:
	   #raise Exception('lines do not intersect')
	   return 0,0
	
	d = (det(*line1), det(*line2))
	x = det(d, xdiff) / div
	y = det(d, ydiff) / div
	return x, y

def getIMUVal(pureData = 0):
	#ERR_IMU=0
	global ERR_IMU
	if imu.IMURead():
	# x, y, z = imu.getFusionData()
	# print("%f %f %f" % (x,y,z))
		data = imu.getIMUData()
		fusionPose = data["fusionPose"]
		accelData  = data["accel"]

		compassData = data["compass"]
		direction = get_direction(compassData[0], compassData[1], compassData[2])
		data = "dir: %s x: %2.2f y: %2.2f z: %1.0f" % (direction, degrees(accelData[0] / -54), degrees(accelData[1] / -54), degrees(accelData[2] / -54))
		#print(data)

		#Rudimentary check for accidents.
		if (degrees(accelData[0] / -54) or degrees(accelData[1] / -54) or (degrees(accelData[2] / -54)+1)) > 1.2:
			ERR_IMU=1
		if not pureData:
			return data,ERR_IMU
		else:
			return direction, degrees(accelData[0] / -54), degrees(accelData[1] / -54), degrees(accelData[2] / -54)
	else: 
		if not pureData:
			return "",ERR_IMU
		else:
			return 0,0,0,0

def updateIMU():
	global errRecordingTime
	direction,x,y,z = getIMUVal(1)
	#print "dir: %s x: %2.2f y: %2.2f z: %1.0f" % (direction,x,y,z)
	if (abs(x) or abs(y) or abs(z+1)) > ACCIDENT_THRESHOLD:
		errRecordingTime = time()
		blue.start(50)
		ERR_IMU=1

	if EXIT == 0:
		t=threading.Timer(.1,updateIMU)
		t.start()
def CheckForFullSpace():
	cmd = "/home/pi/delete_video.sh"
	subprocess.check_output(cmd, shell=True)
	if EXIT == 0:
		t=threading.Timer(5,CheckForFullSpace)
		t.start()


#sleep(1)
#camera.start_preview()
startTime = time()
start = dt.datetime.now()


sleep(1)
#camera.start_preview()
startTime = time()
start = dt.datetime.now()





filename = dt.datetime.now().strftime('%Y-%m-%d_%H:%M:%S:%f') +'.jpg'
camera.annotate_text = filename
frameCounter=0


if __name__ == '__main__':
	try:
		if TESTING == 0:
			os.chdir(SAVE_DIRECTORY)

			t=threading.Timer(.005,updateIMU)
			t.start()
			t1=threading.Timer(5,CheckForFullSpace)
			t1.start()

			pool = mp.Pool( processes=4 )
			p_count = 0   

			camera.capture( rawCapture, format="bgr" )  
			r1 = pool.apply_async( detect_line, [ rawCapture.array ] )    
			r2 = pool.apply_async( detect_line, [ rawCapture.array ] )    
			r3 = pool.apply_async( detect_line, [ rawCapture.array ] )    
			r4 = pool.apply_async( detect_line, [ rawCapture.array ] )    

			img,((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r1.get()
			img,((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r2.get()
			img,((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r3.get()
			img,((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r4.get()

			rawCapture.truncate( 0 )
			camera.start_recording('init.h264')
			startRecordTime = time()
			errRecordingTime =0
			errLaneRecordingTime=0
			
			GPIO.output(WARNING_LED,GPIO.LOW)
			GPIO.output(DANGER_LED,GPIO.LOW)

			
			for frame in camera.capture_continuous( rawCapture, format="bgr", use_video_port=True ):
				image = frame.array

				cv2.line(img,(lx_max1,ly_max1),(lx_max2,ly_max2),(0,255,0),2)
				cv2.line(img,(rx_max1,ry_max1),(rx_max2,ry_max2),(0,255,0),2)
				print (rx_max1,ry_max1),(rx_max2,ry_max2)
				cv2.imshow("line detect test", img)
				cv2.waitKey(1)
				#cv2.destroyAllWindows()

				if   p_count == 1:
					frameCounter+=1
					r1 = pool.apply_async( detect_line, [ image ] )
					img, ((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r2.get()
					

				elif p_count == 2:
					frameCounter+=1
					r2 = pool.apply_async( detect_line, [ image ] )
					img, ((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r3.get()
					

				elif p_count == 3:
					frameCounter+=1
					r3 = pool.apply_async( detect_line, [ image ] )
					img, ((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r4.get()
					

				elif p_count == 4:
					frameCounter+=1
					r4 = pool.apply_async( detect_line, [ image ] )
					img, ((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) =r1.get()
					p_count = 0
				if (dt.datetime.now() - start).seconds > EXECUTION_TIME:
					EXIT=1
					break

				if (time() - startRecordTime) > VIDEO_EXEC_TIME:
					camera.stop_recording()
					filename = dt.datetime.now().strftime('%Y_%m_%d_%H-%M-%S')+'.h264'
					camera.start_recording(filename)
					startRecordTime = time()

				p_count += 1
				camera.annotate_text,ERR_IMU = getIMUVal()
				if errRecordingTime>0:
					if time() > errRecordingTime + ERR_BLINK_TIME:
						blue.stop()
						errRecordingTime =0
						ERR_IMU=0
				elif ERR_IMU:
					print "ERROR"
					errRecordingTime = time()
					blue.start(50)

				
				if errLaneRecordingTime>0:
					if time() > errLaneRecordingTime + WARNING_BLINK_TIME:
						if ERR_WARNING:
							GPIO.output(WARNING_LED,GPIO.LOW)
							#yellow.stop()
							ERR_WARNING =0
						if ERR_DANGER:
							GPIO.output(DANGER_LED,GPIO.LOW)			
							#red.stop()
							ERR_DANGER=0
						errLaneRecordingTime =0

				

				

				rawCapture.truncate(0)
			
			print "Execution time =" + str(time() - startTime)
			print "Frames Captured = %d" % frameCounter
			print "Frames Per Sec = %3.2f" %(frameCounter/(time() - startTime))
		elif TESTING == 1:
			img = cv2.imread('/home/pi/test.jpg')
			img,((lx_max1,ly_max1),(lx_max2,ly_max2),(rx_max1,ry_max1),(rx_max2,ry_max2)) = detect_line(img)
			cv2.line(img,(lx_max1,ly_max1),(lx_max2,ly_max2),(0,255,0),10)
			cv2.line(img,(rx_max1,ry_max1),(rx_max2,ry_max2),(0,255,0),10)
			print (rx_max1,ry_max1),(rx_max2,ry_max2)
			print (lx_max1,ly_max1),(lx_max2,ly_max2)
			cv2.imshow("line detect test", img)
			cv2.waitKey(0)
			cv2.destroyAllWindows()

	finally:
		camera.close()


